"use strict";
/*--------------------------------------------------------*\
|                                                          |
|                          hprose                          |
|                                                          |
| Official WebSite: https://hprose.com                     |
|                                                          |
| index.ts                                                 |
|                                                          |
| @hprose/rpc-plugin-loadbalance for TypeScript.           |
|                                                          |
| LastModified: Feb 25, 2019                               |
| Author: Ma Bingyao <andot@hprose.com>                    |
|                                                          |
\*________________________________________________________*/
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var WeightedLoadBalance = /** @class */ (function () {
    function WeightedLoadBalance(uriList) {
        this.uris = [];
        this.weights = [];
        if (!uriList) {
            throw new Error('uriList cannot be null or undefined');
        }
        for (var uri in uriList) {
            if (!uriList.hasOwnProperty || uriList.hasOwnProperty(uri)) {
                this.uris.push(uri);
                var weight = uriList[uri] | 0;
                if (weight <= 0) {
                    throw new Error('Weight must be great than 0');
                }
                this.weights.push(weight);
            }
        }
        if (this.uris.length === 0) {
            throw new Error('uriList cannot be empty');
        }
    }
    return WeightedLoadBalance;
}());
exports.WeightedLoadBalance = WeightedLoadBalance;
var RandomLoadBalance = /** @class */ (function () {
    function RandomLoadBalance() {
    }
    RandomLoadBalance.prototype.handler = function (request, context, next) {
        var uris = context.client.uris;
        var n = uris.length;
        context.uri = uris[Math.floor(Math.random() * n)];
        return next(request, context);
    };
    return RandomLoadBalance;
}());
exports.RandomLoadBalance = RandomLoadBalance;
var WeightedRandomLoadBalance = /** @class */ (function (_super) {
    __extends(WeightedRandomLoadBalance, _super);
    function WeightedRandomLoadBalance(uriList) {
        var _this = _super.call(this, uriList) || this;
        _this.handler = function (request, context, next) { return __awaiter(_this, void 0, void 0, function () {
            var n, index, totalWeight, currentWeight, i, response, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        n = this.uris.length;
                        index = n - 1;
                        totalWeight = this.effectiveWeights.reduce(function (x, y) { return x + y; });
                        if (totalWeight > 0) {
                            currentWeight = Math.floor(Math.random() * totalWeight);
                            for (i = 0; i < n; ++i) {
                                currentWeight -= this.effectiveWeights[i];
                                if (currentWeight < 0) {
                                    index = i;
                                    break;
                                }
                            }
                        }
                        else {
                            index = Math.floor(Math.random() * n);
                        }
                        context.uri = this.uris[index];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, next(request, context)];
                    case 2:
                        response = _a.sent();
                        if (this.effectiveWeights[index] < this.weights[index]) {
                            this.effectiveWeights[index]++;
                        }
                        return [2 /*return*/, response];
                    case 3:
                        e_1 = _a.sent();
                        if (this.effectiveWeights[index] > 0) {
                            this.effectiveWeights[index]--;
                        }
                        throw e_1;
                    case 4: return [2 /*return*/];
                }
            });
        }); };
        _this.effectiveWeights = _this.weights.slice();
        return _this;
    }
    return WeightedRandomLoadBalance;
}(WeightedLoadBalance));
exports.WeightedRandomLoadBalance = WeightedRandomLoadBalance;
var RoundRobinLoadBalance = /** @class */ (function () {
    function RoundRobinLoadBalance() {
        var _this = this;
        this.index = -1;
        this.handler = function (request, context, next) {
            var uris = context.client.uris;
            var n = uris.length;
            if (n > 1) {
                _this.index = (_this.index + 1) % n;
                context.uri = uris[_this.index];
            }
            return next(request, context);
        };
    }
    return RoundRobinLoadBalance;
}());
exports.RoundRobinLoadBalance = RoundRobinLoadBalance;
function gcd(x, y) {
    var _a, _b;
    if (x < y) {
        _a = [y, x], x = _a[0], y = _a[1];
    }
    while (y !== 0) {
        _b = [y, x % y], x = _b[0], y = _b[1];
    }
    return x;
}
var WeightedRoundRobinLoadBalance = /** @class */ (function (_super) {
    __extends(WeightedRoundRobinLoadBalance, _super);
    function WeightedRoundRobinLoadBalance(uriList) {
        var _this = _super.call(this, uriList) || this;
        _this.index = -1;
        _this.currentWeight = 0;
        _this.handler = function (request, context, next) { return __awaiter(_this, void 0, void 0, function () {
            var n;
            return __generator(this, function (_a) {
                n = this.uris.length;
                while (true) {
                    this.index = (this.index + 1) % n;
                    if (this.index === 0) {
                        this.currentWeight -= this.gcdWeight;
                        if (this.currentWeight <= 0) {
                            this.currentWeight = this.maxWeight;
                        }
                    }
                    if (this.weights[this.index] >= this.currentWeight) {
                        context.uri = this.uris[this.index];
                        return [2 /*return*/, next(request, context)];
                    }
                }
                return [2 /*return*/];
            });
        }); };
        _this.maxWeight = Math.max.apply(Math, _this.weights);
        _this.gcdWeight = _this.weights.reduce(gcd);
        return _this;
    }
    return WeightedRoundRobinLoadBalance;
}(WeightedLoadBalance));
exports.WeightedRoundRobinLoadBalance = WeightedRoundRobinLoadBalance;
var NginxRoundRobinLoadBalance = /** @class */ (function (_super) {
    __extends(NginxRoundRobinLoadBalance, _super);
    function NginxRoundRobinLoadBalance(uriList) {
        var _this = _super.call(this, uriList) || this;
        _this.handler = function (request, context, next) { return __awaiter(_this, void 0, void 0, function () {
            var _a, n, index, totalWeight, currentWeight, response, e_2;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        n = this.uris.length;
                        index = -1;
                        totalWeight = this.effectiveWeights.reduce(function (x, y) { return x + y; });
                        if (totalWeight > 0) {
                            currentWeight = void 0;
                            _a = this.effectiveWeights.reduce(function (previous, current, index) {
                                var currentWeight = (_this.currentWeights[index] += current);
                                return (previous[0] < currentWeight) ? [currentWeight, index] : previous;
                            }, [-Infinity, -1]), currentWeight = _a[0], index = _a[1];
                            this.currentWeights[index] = currentWeight - totalWeight;
                        }
                        else {
                            index = Math.floor(Math.random() * n);
                        }
                        context.uri = this.uris[index];
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, next(request, context)];
                    case 2:
                        response = _b.sent();
                        if (this.effectiveWeights[index] < this.weights[index]) {
                            this.effectiveWeights[index]++;
                        }
                        return [2 /*return*/, response];
                    case 3:
                        e_2 = _b.sent();
                        if (this.effectiveWeights[index] > 0) {
                            this.effectiveWeights[index]--;
                        }
                        throw e_2;
                    case 4: return [2 /*return*/];
                }
            });
        }); };
        var n = _this.uris.length;
        _this.effectiveWeights = _this.weights.slice();
        _this.currentWeights = new Array(n).fill(0);
        return _this;
    }
    return NginxRoundRobinLoadBalance;
}(WeightedLoadBalance));
exports.NginxRoundRobinLoadBalance = NginxRoundRobinLoadBalance;
var LeastActiveLoadBalance = /** @class */ (function () {
    function LeastActiveLoadBalance() {
        var _this = this;
        this.actives = [];
        this.handler = function (request, context, next) { return __awaiter(_this, void 0, void 0, function () {
            var uris, n, leastActive, leastActiveIndexes, i, index, count, response, e_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        uris = context.client.uris;
                        n = uris.length;
                        if (this.actives.length < n) {
                            this.actives.length = n;
                            this.actives.fill(0);
                        }
                        leastActive = Math.min.apply(Math, (this.actives.length > n ? this.actives.slice(0, n) : this.actives));
                        leastActiveIndexes = [];
                        for (i = 0; i < n; ++i) {
                            if (this.actives[i] === leastActive) {
                                leastActiveIndexes.push(i);
                            }
                        }
                        index = leastActiveIndexes[0];
                        count = leastActiveIndexes.length;
                        if (count > 1) {
                            index = leastActiveIndexes[Math.floor(Math.random() * count)];
                        }
                        context.uri = uris[index];
                        this.actives[index]++;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, next(request, context)];
                    case 2:
                        response = _a.sent();
                        this.actives[index]--;
                        return [2 /*return*/, response];
                    case 3:
                        e_3 = _a.sent();
                        this.actives[index]--;
                        throw e_3;
                    case 4: return [2 /*return*/];
                }
            });
        }); };
    }
    return LeastActiveLoadBalance;
}());
exports.LeastActiveLoadBalance = LeastActiveLoadBalance;
var WeightedLeastActiveLoadBalance = /** @class */ (function (_super) {
    __extends(WeightedLeastActiveLoadBalance, _super);
    function WeightedLeastActiveLoadBalance(uriList) {
        var _this = _super.call(this, uriList) || this;
        _this.handler = function (request, context, next) { return __awaiter(_this, void 0, void 0, function () {
            var leastActive, leastActiveIndexes, totalWeight, i, index, n, currentWeight, i, response, e_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        leastActive = Math.min.apply(Math, this.actives);
                        leastActiveIndexes = [];
                        totalWeight = 0;
                        for (i = 0; i < this.weights.length; ++i) {
                            if (this.actives[i] === leastActive) {
                                leastActiveIndexes.push(i);
                                totalWeight += this.effectiveWeights[i];
                            }
                        }
                        index = leastActiveIndexes[0];
                        n = leastActiveIndexes.length;
                        if (n > 1) {
                            if (totalWeight > 0) {
                                currentWeight = Math.floor(Math.random() * totalWeight);
                                for (i = 0; i < n; ++i) {
                                    currentWeight -= this.effectiveWeights[leastActiveIndexes[i]];
                                    if (currentWeight < 0) {
                                        index = leastActiveIndexes[i];
                                        break;
                                    }
                                }
                            }
                            else {
                                index = leastActiveIndexes[Math.floor(Math.random() * n)];
                            }
                        }
                        context.uri = this.uris[index];
                        this.actives[index]++;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, next(request, context)];
                    case 2:
                        response = _a.sent();
                        this.actives[index]--;
                        if (this.effectiveWeights[index] < this.weights[index]) {
                            this.effectiveWeights[index]++;
                        }
                        return [2 /*return*/, response];
                    case 3:
                        e_4 = _a.sent();
                        this.actives[index]--;
                        if (this.effectiveWeights[index] > 0) {
                            this.effectiveWeights[index]--;
                        }
                        throw e_4;
                    case 4: return [2 /*return*/];
                }
            });
        }); };
        var n = _this.uris.length;
        _this.effectiveWeights = _this.weights.slice();
        _this.actives = new Array(n).fill(0);
        return _this;
    }
    return WeightedLeastActiveLoadBalance;
}(WeightedLoadBalance));
exports.WeightedLeastActiveLoadBalance = WeightedLeastActiveLoadBalance;
//# sourceMappingURL=index.js.map